import sys
import os
currentdirectory = os.path.dirname(os.path.realpath(__file__))
sys.path.append(currentdirectory+"/packages/setuptools/")
currentdirectory = os.path.dirname(os.path.realpath(__file__))
sys.path.append(currentdirectory+"/packages/z3/python/")
from z3 import *
init(currentdirectory+"/packages/z3")
set_param(proof=True)

try:
        CONRT_EtherStore= DeclareSort('CONRT_EtherStore')
        _n=Int('_n')
        IsEtherStore= Function('IsEtherStore',CONRT_EtherStore,BoolSort())
        map= DeclareSort('map')
        EtherStore_balances= Function('EtherStore_balances',CONRT_EtherStore,map)
        EtherStore_balances1= Function('EtherStore_balances1',CONRT_EtherStore,map)
        bal= Int('bal')
        total= Int('total')
        bal1= Int('bal1')
        total1= Int('total1')
        sent= Bool('sent')
        sent1= Bool('sent1')
        address= DeclareSort('address')
        msg_sender= Const('msg_sender',address)
        msg_sender1= Const('msg_sender1',address)
        d1FaddressTuint256mapping= Function('d1FaddressTuint256mapping',map,address,IntSort())
        d1FaddressTuint256mapping1= Function('d1FaddressTuint256mapping1',map,address,IntSort())
        TUPLE= DeclareSort('TUPLE')
        TUPLE_0= Const('TUPLE_0',TUPLE)
        TUPLE_01= Const('TUPLE_01',TUPLE)
        TUPLE_1= Const('TUPLE_1',TUPLE)
        TUPLE_11= Const('TUPLE_11',TUPLE)
        LOW_LEVEL_CALL_call= Function('LOW_LEVEL_CALL_call',address,IntSort(),TUPLE)
        LOW_LEVEL_CALL_call1= Function('LOW_LEVEL_CALL_call1',address,IntSort(),TUPLE)
        UNPACK2DTUPLETbool= Function('UNPACK2DTUPLETbool',TUPLE,IntSort(),BoolSort())
        UNPACK2DTUPLETbool1= Function('UNPACK2DTUPLETbool1',TUPLE,IntSort(),BoolSort())
        EXECPTION_LOW_LEVEL_CALL_call = Function('EXECPTION_LOW_LEVEL_CALL_call',TUPLE,BoolSort())
        EXECPTION_LOW_LEVEL_CALL_call1 = Function('EXECPTION_LOW_LEVEL_CALL_call1',TUPLE,BoolSort())
        TUPLE_1= Const('TUPLE_1',TUPLE)
        _A= Const('_A',address) 
        _T= Const('_T',TUPLE) 
        _B= Bool('_B') 
        _S= String('_S') 
        _c= Const('_c',CONRT_EtherStore) 
        _M= Const('_M',map) 
        _I= Int('_I')
        _f=Function('_f',IntSort(),IntSort()) 
        _s=Solver()
        _s.add(ForAll([_n],Implies(_n>=0, _f(_n)==_n)))
        _s.set("timeout",500)
        _s.add(ForAll([_c],Implies(IsEtherStore(_c),EtherStore_balances1(_c) == EtherStore_balances(_c))))
        _s.add(bal1 == bal)
        _s.add(total1 == total)
        _s.add(msg_sender1 == msg_sender)
        _s.add(ForAll([_A,_I],LOW_LEVEL_CALL_call1(_A,_I) == LOW_LEVEL_CALL_call(_A,_I)))
        _s.add(ForAll([_T,_I],UNPACK2DTUPLETbool1(_T,_I) == UNPACK2DTUPLETbool(_T,_I)))
        _s.add(ForAll([_T],EXECPTION_LOW_LEVEL_CALL_call1(_T) == EXECPTION_LOW_LEVEL_CALL_call(_T)))
        _s.add(ForAll([_c,_M,_A],Implies(IsEtherStore(_c),d1FaddressTuint256mapping1(_M,_A) == If(And((_M==EtherStore_balances(_c)),(_A==msg_sender)),0,d1FaddressTuint256mapping(_M,_A)))))        
        _s.add(ForAll([_c],Implies(IsEtherStore(_c),bal1 == d1FaddressTuint256mapping(EtherStore_balances(_c),msg_sender))))       
        _s.add(TUPLE_11 == LOW_LEVEL_CALL_call(msg_sender,bal)) 
        _s.add(sent1 == If((EXECPTION_LOW_LEVEL_CALL_call(LOW_LEVEL_CALL_call(msg_sender,bal))==False),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,bal),0),sent))       
        _s.add(ForAll([_c],Not(Implies(IsEtherStore(_c),(d1FaddressTuint256mapping1(EtherStore_balances(_c),msg_sender)==0)))))
except Exception as e:
	print ("Error(Z3Query)")
	print(e)
	sys.exit(1)

try:
	result=_s.check()
	if sat==result:
		print( "Counter Example")
		print (_s.model())
	elif unsat==result:
		result
		print ("Successfully Proved")
	else:
		print ("Failed To Prove")
except Exception as e:
         print(e)

